#!/bin/bash
#
# Copyright 2012 NetApp, Inc. All Rights Reserved,
# contribution by Weston Andros Adamson <dros@netapp.com>
# 
# This program is free software; you can redistribute it and/or modify it under
# the terms of the GNU General Public License as published by the Free Software
# Foundation; either version 2 of the License, or (at your option) any later
# version.
# This program is distributed in the hope that it will be useful, but WITHOUT
# ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
# FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.
#

# XXX needs better usage
if [ $# -lt 2 -o $# -gt 3 ] ; then
    echo "usage: $0 <set> <setting> <value>"
    echo "   or  $0 <get> <setting>"
    exit 1
fi

# XXX move to argument 
CMD="$1"
NAME="$2"
VALUE="$3"

_thresh_x_get() {
	_sysctl="$1"
	sudo sysctl fs.nfs.${_sysctl} | cut -d= -f2 | sed 's/ //g'
}

_thresh_x_set() {
	_sysctl="$1"
	_value="$2"

	sudo sysctl -w fs.nfs.${_sysctl}=${_value}
	# XXX always set them all
	sudo sysctl -w fs.nfs.nfs_threshold_bitmap=15
}

thresh_r_get() {
	_thresh_x_get nfs_threshold_read_size
}

thresh_r_set() {
	_thresh_x_set nfs_threshold_read_size $*
}

thresh_r_io_get() {
	_thresh_x_get nfs_threshold_read_io_size
}

thresh_r_io_set() {
	_thresh_x_set nfs_threshold_read_io_size $*
}

thresh_w_get() {
	_thresh_x_get nfs_threshold_write_size
}

thresh_w_set() {
	_thresh_x_set nfs_threshold_write_size $*
}

thresh_w_io_get() {
	_thresh_x_get nfs_threshold_write_io_size
}

thresh_w_io_set() {
	_thresh_x_set nfs_threshold_write_io_size $*
}

if [ "$NAME" = "thresh_r" ]; then
    if [ "$CMD" = "get" ] ; then
        thresh_r_get
    elif [ "$CMD" = "set" ] ; then
        thresh_r_set "$VALUE"
    else
        exit 1
    fi

elif [ "$NAME" = "thresh_r_io" ]; then
    if [ "$CMD" = "get" ] ; then
        thresh_r_io_get
    elif [ "$CMD" = "set" ] ; then
        thresh_r_io_set "$VALUE"
    else
        exit 1
    fi

elif [ "$NAME" = "thresh_w" ]; then
    if [ "$CMD" = "get" ] ; then
        thresh_w_get
    elif [ "$CMD" = "set" ] ; then
        thresh_w_set "$VALUE"
    else
        exit 1
    fi

elif [ "$NAME" = "thresh_w_io" ]; then
    if [ "$CMD" = "get" ] ; then
        thresh_w_io_get
    elif [ "$CMD" = "set" ] ; then
        thresh_w_io_set "$VALUE"
    else
        exit 1
    fi

else
	exit 1
fi

